package com.lionel.linq;

import java.lang.reflect.Type;

import com.lionel.linq.expressions.Expression;

/**
 * LINQ-to-Entities is a LINQ provider that has a set of extension methods on
 * Queryable. The methods build up an expression tree (which is why delegates
 * are actually passed as Expression), and the provider will build up a SQL
 * query based on its parsing of that expression tree.
 * 
 * @author huynt3
 * 
 */
public class Queryable extends Enumerable implements IQueryable {
	private Type elementType;
	private Expression expression;
	private QueryProvider provider;
	
	public Type getType() {
		return elementType;
	}
	
	public Expression getExpression() {
		return expression;
	}
	
	public QueryProvider getProvider() {
		return provider;
	}
}
