package com.lionel.linq.expressions.test;

import com.lionel.linq.expressions.BinaryExpression;
import com.lionel.linq.expressions.ConstantExpression;
import com.lionel.linq.expressions.Expression;
import com.lionel.linq.expressions.Func;
import com.lionel.linq.expressions.LambdaExpression;
import com.lionel.linq.expressions.ParameterExpression;

public class LambdaExpressionTest {
	@SuppressWarnings("unchecked")
	public static void main(String[] args) {
		// A parameter for the lambda expression.
		ParameterExpression paramExpr = Expression.parameter(Integer.class,
				"arg");
		ConstantExpression constExpr = Expression.constant(1);
		BinaryExpression binaryExpr = Expression.add(paramExpr, constExpr);

		// This expression represents a lambda expression
		// that adds 1 to the parameter value.
		LambdaExpression lamdaExpr = Expression.lamda(binaryExpr);

		// Print out the expression.
		System.out.println(lamdaExpr);

		// Compile and run the lamda expression.
		// The value of the parameter is 1.
		 System.out.println(((Func<Integer,Integer>)lamdaExpr.compile()).invoke(3));

		// This code example produces the following output:
		//
		// arg => (arg + 1)
		// 2
	}
}
