package com.lionel.linq.test;

import java.util.ArrayList;
import java.util.Arrays;
import com.lionel.linq.Enumerable;
import com.lionel.linq.expressions.Func;

public class EnumerableTest {
	public static void main(String[] args) {
		Integer[] numbers = { 5, 10, 8, 3, 6, 12 };
		Func<Integer, Boolean> evenNumber = new Func<Integer, Boolean>() {
			@Override
			public Boolean invoke(Integer arg) {
				return arg % 2 == 0;
			}
		};
		Iterable<Integer> numQuery = Enumerable.where(Arrays.asList(numbers),
				evenNumber);
		System.out.println(numQuery);

		ArrayList<Student> students = new ArrayList<Student>() {
			private static final long serialVersionUID = 7544796862919486278L;
			{
				add(new Student("Svetlana", 98));
				add(new Student("Claire", 75));
				add(new Student("Sven", 88));
				add(new Student("Cesar", 97));
			}
		};
		Func<Student, Boolean> highClass = new Func<Student, Boolean>() {
			@Override
			public Boolean invoke(Student student) {
				// TODO Auto-generated method stub
				return student.score > 95;
			}
		};
		Iterable<Student> query = Enumerable.where(students, highClass);
		for (Student s : query) {
			System.out.printf("%s:%d\n", s.name, s.score);
		}
	}
}
